<?php
session_start();

require("../config.php");

$chat_file = "../chat/chat_log.txt";
$kicked_file = "../chat/kicked_file.txt";
$banned_file = "../chat/banned_file.txt";

// If the user is not an admin
if(!isset($_SESSION['chat_admin']) || $_SESSION['chat_admin'] != 1)
	die(json_encode(array("error" => "Denied")));
	
if(!isset($_GET['function']))
	die;
	
$function = htmlentities($_GET['function']);
$log = array();

switch($function) {

	case ('kick'):
	
		// Check if user is set in the URL
		if(!isset($_GET['user']))
			die(json_encode(array("error" => "Invalid User")));
			
		// Check if the user tried to kick themself
		if($_SESSION['chat_user'] == $_GET['user'])
			die(json_encode(array("error" => "Self Kick")));
			
		// Check if the user has been kicked
		if(in_array($_GET['user'], file($kicked_file)))
			die(json_encode(array("error" => "Repeat")));	
	
		include("../connect.php");
		
		// Query the database
		$user = mysqli_real_escape_string($connection, $_GET['user']);
		$sql = mysqli_query($connection, "SELECT `user` FROM `chat_users` WHERE `user` = '{$user}'");
		mysqli_close($connection);

		// Check if the user does not exist
		if(mysqli_num_rows($sql) == 0)
			die(json_encode(array("error" => "Invalid User")));
			
		fwrite(fopen($kicked_file, 'a'), "\n".htmlentities($_GET['user']));
		
		$log = htmlentities($_GET['user'])." has been kicked.";
	
	break;


	case ('ban'):
	
		// Check if user is set in the URL
		if(!isset($_GET['user']))
			die(json_encode(array("error" => "Invalid User")));
			
		// Check if the user tried to ban themself
		if($_SESSION['chat_user'] == $_GET['user'])
			die(json_encode(array("error" => "Self Ban")));
			
		// For each line in the file
		foreach(file($banned_file) as $line_num => $line) {

			// If the line contains the requested user
			if(strpos($line, $_GET['user']." ") !== false)
				die(json_encode(array("error" => "Repeat")));

		}

		include("../connect.php");
		
		// Query the database
		$user = mysqli_real_escape_string($connection, $_GET['user']);
		$sql = mysqli_query($connection, "SELECT `user` FROM `chat_users` WHERE `user` = '{$user}'");
        mysqli_close($connection);

		// Check if the user does not exist
		if(mysqli_num_rows($sql) == 0)
			die(json_encode(array("error" => "Invalid User")));
	
		fwrite(fopen($banned_file, 'a'), "\n".htmlentities($user)." ".time()." ".$ban_time);
		
		$log = htmlentities($user)." has been banned.";
	
	break;
	
	case ('delete'):
	
		// Check if the id is set in the URL
		if(!isset($_GET['id']) || !ctype_digit($_GET['id']))
			die(json_encode(array("error" => "Invalid ID")));

		// Check if the line exists
		if(count(file($chat_file)) < $_GET['id'] && count(file($chat_file)) > $_GET['id'])
			die(json_encode(array("error" => "Invalid ID")));
	
		require("../functions.php");
		delete_message($_GET['id'], $chat_file);
	
	break;


}

echo json_encode($log);

?>