<?php
session_start();
require("config.php");

$kicked_file = "chat/kicked_file.txt";
$banned_file = "chat/banned_file.txt";

if(!isset($_SESSION['chat_user'])) {
	header("Location: chat/login.php");
	die;
}

include("admin/check.php");

if($_SERVER['REQUEST_METHOD'] === "POST") {

	// Spam attempt
	if(isset($_POST['token']) && $_POST['token'] != "")
		die("Spam attempt detected.");

	require_once("functions.php");
	send_chat($_SESSION['chat_user'], $_POST['chat_mes']);

}
?>
<!DOCTYPE html>
<html>

<head>

	<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />

	<title>MDCode | Chat</title>
	
	<link href="css/bootstrap.css" rel="stylesheet" type="text/css" />
	<link href="css/chat.css" rel="stylesheet" type="text/css" />

	<script src="//ajax.googleapis.com/ajax/libs/jquery/1.4/jquery.min.js" type="text/javascript"></script>
	<script type="text/javascript" src="js/chat.js"></script>
	<script type="text/javascript" src="js/settings.js"></script>
	<script type="text/javascript" src="js/jquery.js"></script>
	<script type="text/javascript" src="js/modal.js"></script>
	
	<script type="text/javascript">
	$(document).ready(function() {

		$("div#loading").css("display", "inline");
		$("div#bbcode").show();
		
	});
		var chat = new Chat();
		chat.init();
    	
	function insert(emote) {
		document.getElementById('chat_text').value += emote;
	}
	</script>

</head>

<body>
	
	<h1 style="text-align: center;">MDCode Chat</h1>
	
	<div id="emoticons" class="modal hide fade" tabindex="-1" role="dialog" aria-labelledby="Emoticons" aria-hidden="true">
		<div class="modal-header">
			<button type="button" class="close" data-dismiss="modal" aria-hidden="true">×</button>
			<h3 id="Emoticons">Emoticons</h3>
		</div>
		<div class="modal-body">
			<a href="javascript:void(0)" onclick="insert(':)')"><img src="css/images/emotes/happy.gif"/></a>
			<a href="javascript:void(0)" onclick="insert(':D')"><img src="css/images/emotes/happy02.gif"/></a>
			<a href="javascript:void(0)" onclick="insert(';D')"><img src="css/images/emotes/happy03.gif"/></a>
			<a href="javascript:void(0)" onclick="insert(';)')"><img src="css/images/emotes/wink.gif"/></a>
			<a href="javascript:void(0)" onclick="insert(':(')"><img src="css/images/emotes/sad.gif"/></a>
			<a href="javascript:void(0)" onclick="insert(':\'\(')"><img src="css/images/emotes/cry.gif"/></a>
			<a href="javascript:void(0)" onclick="insert(';)')"><img src="css/images/emotes/mad.gif"/></a>
			<a href="javascript:void(0)" onclick="insert(':P')"><img src="css/images/emotes/tongue.gif"/></a>
			<a href="javascript:void(0)" onclick="insert(':p')"><img src="css/images/emotes/tongue02.gif"/></a>
			<a href="javascript:void(0)" onclick="insert(';P')"><img src="css/images/emotes/tongue03.gif"/></a>
			<a href="javascript:void(0)" onclick="insert(':o')"><img src="css/images/emotes/excl.gif"/></a>
			<a href="javascript:void(0)" onclick="insert(':rolleyes:')"><img src="css/images/emotes/rolleyes.gif"/></a>
			<a href="javascript:void(0)" onclick="insert('8)')"><img src="css/images/emotes/cool.gif"/></a>
			<a href="javascript:void(0)" onclick="insert(':thumbup:')"><img src="css/images/emotes/thumbup.gif"/></a>
			<a href="javascript:void(0)" onclick="insert(':shy:')"><img src="css/images/emotes/shy.gif"/></a>
			<a href="javascript:void(0)" onclick="insert(':quiet:')"><img src="css/images/emotes/quiet.gif"/></a>
			<a href="javascript:void(0)" onclick="insert(':kiss:')"><img src="css/images/emotes/kiss.gif"/></a>
			<a href="javascript:void(0)" onclick="insert(':awkward:')"><img src="css/images/emotes/awkward.gif"/></a>
			<a href="javascript:void(0)" onclick="insert(':facepalm:')"><img src="css/images/emotes/facepalm.gif"/></a>
			<a href="javascript:void(0)" onclick="insert(':wtf:')"><img src="css/images/emotes/wtf.gif"/></a>
			<a href="javascript:void(0)" onclick="insert(':confused:')"><img src="css/images/emotes/confused.gif"/></a>
			<a href="javascript:void(0)" onclick="insert(':shrug:')"><img src="css/images/emotes/shrug.gif"/></a>
			<a href="javascript:void(0)" onclick="insert(':facewall:')"><img src="css/images/emotes/facewall.gif"/></a>
			<a href="javascript:void(0)" onclick="insert(':hammertime:')"><img src="css/images/emotes/hammertime.gif"/></a>
			<a href="javascript:void(0)" onclick="insert(':ninja:')"><img src="css/images/emotes/ninja.gif"/></a>
			<a href="javascript:void(0)" onclick="insert(':birthday:')"><img src="css/images/emotes/party.gif"/></a>
			<a href="javascript:void(0)" onclick="insert(':rules:')"><img src="css/images/emotes/rules.gif"/></a>
		</div>
		<div class="modal-footer">
			<button class="btn" data-dismiss="modal" aria-hidden="true">Close</button>
		</div>
	</div>
	
	<noscript><div class="alert alert-error" style="width: 500px; text-align: center; margin-left: auto; margin-right: auto;">JavaScript is disabled on your browser.  Chat will not work as best as it can until you enable it.</div></noscript>
	
	<?php
	if($display_v == "1") {
			
		require_once("functions.php");
			
		if(latest_version() !== true) {
				
			echo "<div class='alert alert-error' style='width: 500px; text-align: center; margin-left: auto; margin-right: auto;'>**Attention: A newer version of this script is available for download.  We strongly recommend you upgrade this version.  You can disable this message in the configurations file.</div>";
					
		}
				
	}
	?>
	
	<div id="chat_container">
		<div id="loading" style="display:none;"><div class='chat_message'><span class='system_user'>System</span>: Loading Messages... Please wait.</div></div>
		<noscript><?php include("chat/noscript.php"); ?></noscript>
	</div>
	
	<div class="bottom">
	
			<div class="chat_divider"></div>
			
			<div id="bbcode" style="display: none;">

				<!-- Emoticons -->
				<a href="#emoticons" role="button" data-toggle="modal" title="Emoticons"><img src="css/images/emotes/happy.gif" /></a>
			
				<!-- Bold -->
				<a href="javascript:void(0)" onclick="document.getElementById('chat_text').value += '[b][/b]'" title="Bold" /><img src="css/images/bbcode_bold.gif" /></a>
				
				<!-- Italic -->
				<a href="javascript:void(0)" onclick="document.getElementById('chat_text').value += '[i][/i]'" title="Italic" /><img src="css/images/bbcode_italic.gif" /></a>
				
				<!-- Underline -->
				<a href="javascript:void(0)" onclick="document.getElementById('chat_text').value += '[u][/u]'" title="Underline" /><img src="css/images/bbcode_underline.gif" /></a>
			
				<!-- Hyperlink -->
				<a href="javascript:void(0)" onclick="document.getElementById('chat_text').value += '[url=]Link Name[/url]'" title="Hyperlink" /><img src="css/images/bbcode_hyperlink.gif" /></a>

				<!-- Help -->
				<a href="javascript:void(0)" onclick="sendChat('/help')" title="Chat Help" /><img src="css/images/bbcode_help.png" /></a>
				
			</div>

			<noscript><div id="bbcode">Please enable JavaScript to use BBCode.</div></noscript>

			<span class="pull-right" style="position: absolute; right: 20px; top: 5px;">
					
				<!-- User Panel -->
				<?php
				if(isset($_SESSION['chat_admin']) && $_SESSION['chat_admin'] == 1)
					echo "<a href='admin/panel.php' class='btn btn-mini'>Admin Panel</a> ";
				else
					echo "<a href='chat/user_panel.php' class='btn btn-mini'>User Panel</a> ";
				?>

				<!-- Logout -->
				<a href='chat/logout.php' class='btn btn-mini'>Logout</a>
				
			</span>
			
			<form method="post">
				<input type="text" id="token" name="token" value="" style="display: none;" />
				<input type="text" id="chat_text" placeholder="Enter Message..." maxlength="250" name="chat_mes" />
				<button type="submit" style="visibility: hidden;">Send</button>
			</form>
		
		</div>

</body>
</html>