<?php
session_start();

if(!file_exists("../connect.php")) {
	header("Location: ../install/install.php");
	die;
}

if(isset($_SESSION['chat_user'])) {
	header("Location: ../chat.php");
	die;
}

if($_SERVER['REQUEST_METHOD'] === "POST") {

	if(preg_match('/[^a-zA-Z]/', $_POST['user']) || strlen($_POST['pass']) < 6)
		$error = "Invalid credentials supplied.  Please try again.";

	if(empty($_POST['user']) || empty($_POST['pass']))
		$error = "Please fill in all fields.";

	if(empty($error)) {

		include("../connect.php");
		require("functions.php");
		require("../functions.php");

		$user = mysqli_real_escape_string($connection, $_POST['user']);
        mysqli_close($connection);

		login($user, Secure($_POST['pass']));

	}

}
?>
<!DOCTYPE html>
<html>

<head>

	<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />

	<title>MDCode | Chat</title>
	
	<link href="../css/bootstrap.css" rel="stylesheet" type="text/css" />

</head>

<body style="text-align: center;">

<h1>MDCode Chat</h1>

<div class="container">

	<div class="row">

		<div class="span6 offset3 well">

			<h3>Login</h3>
			
			<?php
			if(isset($error))
				echo "<div class='alert alert-error'><b>ERROR</b>: $error</div>";
			else if(isset($_GET['log']) && $_GET['log'] == "fail")
				echo "<div class='alert alert-error'><b>ERROR</b>: Invalid credentials supplied.  Please try again.</div>";
			else if(isset($_GET['reg']) && $_GET['reg'] == "new")
				echo "<div class='alert alert-success'><b>SUCCESS</b>: You have been registered successfully!  You may now log in.</div>";
			?>

			<form method="post">

				<input type="text" class="span6" name="user" value="<?php echo (isset($_POST['user']) ? htmlentities($_POST['user']) : ''); ?>" placeholder="Username" maxlength="20">
				<input type="password" class="span6" name="pass" placeholder="Password">
				
				<button type="submit" name="submit" class="btn btn-inverse btn-block">Login</button>
				
				<p style="margin-top: 20px;">No Account?  <a href="register.php">Register here!</a></p>
				
			</form>
		
		</div>
	
	</div>

</div>

</body>
</html>