<?php
// If you rename the log file, be sure to update it here
$chat_file = "chat/chat_log.txt";
$kicked_file = "chat/kicked_file.txt";
$banned_file = "chat/banned_file.txt";

$user = htmlentities($_SESSION['chat_user']);
$admin = htmlentities($_SESSION['chat_admin']);

// How many messages do you want to show on the first load?
$messages_to_show = 100;

$text = array();

// Check if they are kicked	
if(in_array($_SESSION['chat_user'], file($kicked_file))) {
	$kicked = 1;
	$text[] = "<div class='inner_center'>You have been kicked from chat.<br /><br /> <a href='chat.php' class='btn btn-primary'>Relaunch</a></div>";
}
	
// For each line in the banned file
foreach(file($banned_file) as $line_num => $line) {

	// If the line contains the session user
	if(strpos($line, $_SESSION['chat_user']." ") !== false) {

		// Set $banned so we know they are in the file
		$banned = 1;

		// Remove spaces and insert each section into an array
		$line = explode(" ", $line);

		// The time they were banned, and how long they were banned for
		$ban_time = $line['1'];
		$how_long = $line['2'];

		// The formula to check the amount of minutes left in the ban
		$time_left = ceil(($ban_time + ($how_long * 60) - time()) / 60);

	}

}
		
// If they are banned (First check if they are kicked so there isn't a display issue)
if($kicked != 1 && $banned == 1) {

	if($time_left > 0)
		$text[] = "<div class='inner_center'>You have been banned from chat.<br /> You can chat again in $time_left minute(s).</div>";
	else
		$text[] = "<div class='inner_center'>Your ban has expired.<br />  You may now chat again.<br /><br /><a href='chat.php' class='btn btn-primary'>Relaunch</a></div>";

}

if($kicked != 1 && $banned != 1) {
        
	foreach (file($chat_file) as $line_num => $line) {
		
		if ($line_num >= $state) {
		
			// Prevent a small issue with a user posting the first message in the file
			if($line != "\n") {
		
				// Split the message into an array, separated by spaces
				$receiver = explode(" ", $line);
				
				if($admin == 1) {
					$options = "<a href='javascript:void(0)' class='icon-remove'></a>";
				} else
					// For future versions
					$options = "";
			
				// Remove the user information at the beginning of the message.  We will add it in later.
				$line = str_replace("$receiver[0] - ", "", $line);


				// If the chat sender is the session user, and it contains /tell at the beginning
				if($receiver['0'] == $user && $receiver[2] == "/tell") {
				
					// Remove /tell user
					$replace = array("/tell ".$receiver[3]);
					$replacement = array("");
					$line = str_replace($replace, $replacement, $line);
				
					// Create the private message to another user
					$text[] = "<div class='chat_message'>$options You tell <span class='chat_user'><a href='javascript:void(0)' onclick='document.getElementById(\"chat_text\").value = \"/tell ".$receiver['3']." \"; document.getElementById(\"chat_text\").focus(); return false;'>".$receiver['3']."</a></span>: <span class='private'>".str_replace("\n", "", $line)."</span></div>";
			
				// If the chat sender is not the session user, it contains /tell at the beginning and they are not the target
				} else if($receiver['0'] != $user && $receiver['2'] == "/tell" && $receiver['3'] != $user) {
				
					// Hide any private message that is not meant for the user.  If an admin is logged in, show all private messages
					if($admin == 1) {
						$replace = array("/tell ".$receiver['3']);
						$replacement = array("");
						$line = str_replace($replace, $replacement, $line);
				
						$text[] = "<div class='chat_message'>$options <span class='chat_user'><a href='javascript:void(0)' onclick='document.getElementById(\"chat_text\").value = \"/tell ".$receiver['0']." \"; document.getElementById(\"chat_text\").focus(); return false;'>".$receiver['0']."</a></span> tells <span class='chat_user'><a href='javascript:void(0)' onclick='document.getElementById(\"chat_text\").value = \"/tell ".$receiver['3']." \"; document.getElementById(\"chat_text\").focus(); return false;'>".$receiver['3']."</a></span>: <span class='private'>".str_replace("\n", "", $line)."</span></div>";
					} else
						$text[] = "";
				
				// If the chat sender is not the session user, it contains /tell at the beginning and they are the target
				} else if($receiver['0'] != $user && $receiver['2'] == "/tell" && $receiver['3'] == $user) {
	
					// Remove /tell user
					$replace = array("/tell ".$receiver['3']);
					$replacement = array("");
					$line = str_replace($replace, $replacement, $line);
				
					// Create the private message to the user
					$text[] = "<div class='chat_message'>$options <span class='chat_user'><a href='javascript:void(0)' onclick='document.getElementById(\"chat_text\").value = \"/tell ".$receiver['0']." \"; document.getElementById(\"chat_text\").focus(); return false;'>".$receiver['0']."</a></span> tells you: <span class='private'>".str_replace("\n", "", $line)."</span></div>";
					
				// If someone is trying to make an announcement.
				} else if($receiver['2'] == "/announce") {
			
					// Remove /announce
					$replace = array("/announce ");
					$replacement = array("");
					$line = str_replace($replace, $replacement, $line);
			
					$text[] = "<div class='chat_message'>$options <span class='system_user'>".$receiver['0']."</span>: ".str_replace("\n", "", $line)."</span></div>";

				} else {
				
					// If the sender is the user, no need to allow to click their own name
					if($receiver['0'] == $user)
						$text[] = "<div class='chat_message'>$options <span class='chat_user'>".$receiver['0']."</span>: ".str_replace("\n", "", $line)."</div>";
					else
						$text[] = "<div class='chat_message'>$options <span class='chat_user'><a href='javascript:void(0)' onclick='document.getElementById(\"chat_text\").value = \"/tell ".$receiver['0']." \"; document.getElementById(\"chat_text\").focus(); return false;'>".$receiver['0']."</a></span>: ".str_replace("\n", "", $line)."</div>";
		
				}
			
			}
	
		}
		
	}

}

foreach($text as $message) {

	echo $message;
	
}
?>