<?php
session_start();

if(!isset($_SESSION['chat_user']))
	die(json_encode(array("error" => "Expired")));

// If you rename the log files, be sure to update it here
$chat_file = "chat_log.txt";
$kicked_file = "kicked_file.txt";
$banned_file = "banned_file.txt";

// Check if the requested function exists
if(!isset($_POST['function']))
	die;

$function = htmlentities($_POST['function'], ENT_QUOTES);
require("../config.php");

$log = array();
    
switch ($function) {

	case ('getUser'):

		// Get the session user
		if(isset($_SESSION['chat_user']))
			$log[] = $_SESSION['chat_user'];
		
		// Get the admin status
		if(isset($_SESSION['chat_admin']) && $_SESSION['chat_admin'] == 1)
			$log[] = 1;
		else
			$log[] = 0;
		
		// Check if they are kicked	
		if(in_array($_SESSION['chat_user'], file($kicked_file)))
			$log[] = 1;
		else
			$log[] = 0;

		// For each line in the banned file
		foreach(file($banned_file) as $line_num => $line) {

			// If the line contains the session user
			if(strpos($line, $_SESSION['chat_user']." ") !== false) {

				// Set $banned so we know they are in the file
				$banned = 1;

				// Remove spaces and insert each section into an array
				$line = explode(" ", $line);

				// The time they were banned, and how long they were banned for
				$ban_time = $line['1'];
				$how_long = $line['2'];

				// The formula to check the amount of minutes left in the ban
				$time_left = ceil(($ban_time + ($how_long * 60) - time()) / 60);

			}

		}
		
		// If they are banned
		if($banned == 1)
			$log[] = $time_left;
		else
			$log[] = "no";
	
	break;

	case ('getState'):

		if (file_exists($chat_file)) {
			$lines = file($chat_file);
                        $lines = array_values(array_filter($lines, "trim"));
                }

		$log['state'] = count($lines);
              
	break;	
        	 
	case ('send'):


		// Check if they are kicked	
		if(in_array($_SESSION['chat_user'], file($kicked_file)))
			die(json_encode(array(error => "Kicked")));
			
		// For each line in the banned file
		foreach(file($banned_file) as $line_num => $line) {

			// If the line contains the session user
			if(strpos($line, $_SESSION['chat_user']." ") !== false) {
			
				// Remove spaces and insert each section into an array
				$line = explode(" ", $line);

				// The time they were banned, and how long they were banned for
				$ban_time = $line['1'];
				$how_long = $line['2'];

				// Return the ban
				die(json_encode(array("error" => "Banned", "time_left" => ceil(($ban_time + ($how_long * 60) - time()) / 60))));

			}

		}
		
		$mess = explode(" ", $_POST['message']);

		// If the user is trying to use an admin command and they are not an admin (kick and ban will not be processed through PHP)
		if(!isset($_SESSION['chat_admin']) || $_SESSION['chat_admin'] != 1) {
			if($mess['0'] == "/announce")
				die(json_encode(array("error" => "Denied")));
		}
		
		// Check if the user has tried to private message themself
                if(isset($mess['1'])) {
		        if($mess['0'] == "/tell" && $mess['1'] == $_SESSION['chat_user'])
			        die(json_encode(array("error" => "Self Tell")));

                }

		$nickname = htmlentities($_SESSION['chat_user'], ENT_QUOTES);
			
		// Emoticons
		$patterns = array(
			"/:\)/",
			"/:D/",
			"/;D/",
			"/;\)/",
			"/:\(/",
			"/:'\(/",
			"/;\(/",
			"/:P/",
			"/:p/",
			"/;P/",
			"/:o/",
			"/8\)/",
			"/:shy:/",
			"/:quiet:/",
			"/:kiss:/",
			"/:awkward:/",
			"/:wtf:/",
			"/:confused:/",
			"/:shrug:/",
			"/:facepalm:/",
			"/:facewall:/",
			"/:hammertime:/",
			"/:thumbup:/",
			"/:rolleyes:/",
			"/:ninja:/",
			"/:birthday:/",
			"/:rules:/"
			
			);
			
		// Emoticon Replacements
		$replacements = array(
			"<img src='css/images/emotes/happy.gif'/>",
			"<img src='css/images/emotes/happy02.gif'/>",
			"<img src='css/images/emotes/happy03.gif'/>",
			"<img src='css/images/emotes/wink.gif'/>",
			"<img src='css/images/emotes/sad.gif'/>",
			"<img src='css/images/emotes/cry.gif'/>",
			"<img src='css/images/emotes/mad.gif'/>",
			"<img src='css/images/emotes/tongue.gif'/>",
			"<img src='css/images/emotes/tongue02.gif'/>",
			"<img src='css/images/emotes/tongue03.gif'/>",
			"<img src='css/images/emotes/excl.gif'/>",
			"<img src='css/images/emotes/cool.gif'/>",
			"<img src='css/images/emotes/shy.gif'/>",
			"<img src='css/images/emotes/quiet.gif'/>",
			"<img src='css/images/emotes/kiss.gif'/>",
			"<img src='css/images/emotes/awkward.gif'/>",
			"<img src='css/images/emotes/wtf.gif'/>",
			"<img src='css/images/emotes/confused.gif'/>",
			"<img src='css/images/emotes/shrug.gif'/>",
			"<img src='css/images/emotes/facepalm.gif'/>",
			"<img src='css/images/emotes/facewall.gif'/>",
			"<img src='css/images/emotes/hammertime.gif'/>",
			"<img src='css/images/emotes/thumbup.gif'/>",
			"<img src='css/images/emotes/rolleyes.gif'/>",
			"<img src='css/images/emotes/ninja.gif'/>",
			"<img src='css/images/emotes/party.gif'/>",
			"<img src='css/images/emotes/rules.gif'/>"
				
			);

		$blankexp = "/^\n/";
		$message = htmlentities($_POST['message'], ENT_QUOTES);
		
		require("../functions.php");
		$message = bbcode($message);
			
		// If the admin chooses to filter chat
		if($filter == 1 && $filter_all == 0)
			$message = filter($message);
		else if($filter == 1 && $filter_all == 1)
			$message = filter($message, false);

		// If the message is not blank
		if (!preg_match($blankexp, $message)  && trim($message) != "") {

			// Replace all necessary elements
			$message = str_replace("&#039;", "'", $message);
			$message = preg_replace("/javascript:/", "", $message);
			$message = preg_replace("/\/tell/", "&#47;tell", $message);
			$message = preg_replace("/&#47;tell/",  "/tell", $message, 1);
			$message = trim(preg_replace($patterns, $replacements, $message));
			$message = str_replace("\n", " ", $message);
    			 
		 	// Write to the file
		 	if(strpos(end(file($chat_file)), "\n") === false)
		 		fwrite(fopen($chat_file, 'a'), "\n".$nickname." - ".$message."\n");
		 	else
				fwrite(fopen($chat_file, 'a'), $nickname." - ".$message."\n");

			// If the user has posted a message within 2 seconds of their last
			if(isset($_SESSION['chat_posts']) && (time() - 2) < $_SESSION['chat_post_time']) {
			
				// Increment the posts and get the new post time
				$_SESSION['chat_posts'] = $_SESSION['chat_posts'] + 1;
				$_SESSION['chat_post_time'] = time();
				
				// If the user has posted the limit
				if($_SESSION['chat_posts'] == $post_limit) {
				
					// Remove the posts and post time
					unset($_SESSION['chat_posts'], $_SESSION['chat_post_time']);
					
					// Insert the ban
					fwrite(fopen($banned_file, 'a'), htmlentities($_SESSION['chat_user'])." ".time()." ".$ban_time."\n");
					fwrite(fopen($chat_file, 'a'), "System - /announce ".$nickname." has been banned for spamming.\n");

				}

			// If the user has posted a new message
			} else {

				$_SESSION['chat_post_time'] = time();
				$_SESSION['chat_posts'] = 1;

			}

		}

	break;

}
    
	echo json_encode($log);

?>