<?php
session_start();

if(!file_exists("../connect.php")) {
	header("Location: ../install/install.php");
	die;
}

if(isset($_SESSION['chat_user'])) {
	header("Location: ../chat.php");
	die;
}

if($_SERVER['REQUEST_METHOD'] === "POST") {

	if(isset($_POST['token']) && $_POST['token'] != "")
		die("Spam attempt detected.");

	require("../functions.php");
	
	$user = filter($_POST['user'], false);

	if(preg_match('/[^a-zA-Z]/', $user))
		$error = "Username must contain all letters and be appropriate.";
		
	if(strlen($_POST['user']) > 20)
		$error = "Please limit your username to 20 characters.";
		
	if(strlen($_POST['pass']) < 6)
		$error = "Passwords must be minimum of 6 characters.";
		
	if($_POST['pass'] != $_POST['c_pass'])
		$error = "The two passwords do not match";

	if(empty($_POST['user']) || empty($_POST['pass']) || empty($_POST['c_pass']))
		$error = "Please fill in all fields.";

	if(empty($error)) {
	
		include("../connect.php");
		require("functions.php");

        $user = mysqli_real_escape_string($connection, $_POST['user']);
		$sql = mysqli_query($connection, "SELECT `user` FROM `chat_users` WHERE `user` = '{$user}'");
        mysqli_close($connection);
		
		if(mysqli_num_rows($sql) != 0)
			$error = "The specified user already exists";
	
		if(empty($error)) {

			register($user, Secure($_POST['pass']));
			
		}

	}

}
?>
<!DOCTYPE html>
<html>

<head>

	<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />

	<title>MDCode | Chat</title>
	
	<link href="../css/bootstrap.css" rel="stylesheet" type="text/css" />

</head>

<body style="text-align: center;">

<h1>MDCode Chat</h1>

<div class="container">

	<div class="row">

		<div class="span6 offset3 well">

			<h3>Register</h3>
			
			<?php
			if(isset($error)) {
			
				echo "<div class='alert alert-error'><b>ERROR</b>: $error</div>";
			
			}
			?>

			<form method="post">

				<input type="text" class="span6" name="user" value="<?php echo (isset($_POST['user']) ? htmlentities($_POST['user']) : ''); ?>" placeholder="Username" maxlength="20">
				<input type="password" class="span6" name="pass" placeholder="Password">
				<input type="password" class="span6" name="c_pass" placeholder="Confirm Password">
				<input type="token" name="token" value="" style="display: none;">
				
				<button type="submit" name="submit" class="btn btn-inverse btn-block">Register</button>
				
				<p style="margin-top: 20px;">Already have an account? <a href="login.php">Login here!</a></p>
				
			</form>
		
		</div>
	
	</div>

</div>

</body>
</html>