<?php 
// If you rename the log file, be sure to update it here
$file = "chat_log.txt";

// If the essential variables are not set, we need to end the script
if(!isset($_GET['state'], $_GET['user'], $_GET['admin'], $_GET['kicked'], $_GET['banned']))
	die;

$state = htmlentities($_GET['state'], ENT_QUOTES);
$user = htmlentities($_GET['user'], ENT_QUOTES);
$admin = htmlentities($_GET['admin'], ENT_QUOTES);
$kicked = htmlentities($_GET['kicked'], ENT_QUOTES);
$banned = htmlentities($_GET['banned'], ENT_QUOTES);

if($kicked == 1 || $banned != "no")
	die;

$finish = time() + 50;
$count = count(file($file));
    
while ($count <= $state) {
    
	$now = time();
	usleep(10000);
        
	if ($now <= $finish) {
		$count = count(file($file));
	} else {
		break;	
	}  
         
}		 
    
if ($state == $count) {
    
	$log['state'] = $state;
	$log['t'] = "continue";
        
} else {

	$text= array();
	$log['state'] = $state + count(file($file)) - $state;
	
        
	foreach (file($file) as $line_num => $line) {
		
		// If the line number is less than the state
		if ($line_num >= $state) {
		
			// Prevent a small issue with a user posting the first message in the file
			if($line != "\n") {

				// Split the message into an array, separated by spaces
				$receiver = explode(" ", $line);
				
				if($admin == 1) {
					// The delete option
					$line_num = $line_num + 1;
					$options = "<a href='javascript:void(0)' onclick='deleteMessage(\"".$line_num."\")' class='icon-remove'></a>";
				} else
					// For future versions
					$options = "";
			
				// Remove the user information at the beginning of the message.  We will add it in later.
				$line = str_replace("$receiver[0] - ", "", $line);


				// If the chat sender is the session user, and it contains /tell at the beginning
				if($receiver['0'] == $user && $receiver[2] == "/tell") {
				
					// Remove /tell user
					$replace = array("/tell ".$receiver[3]);
					$replacement = array("");
					$line = str_replace($replace, $replacement, $line);
				
					// Create the private message to another user
					$text[] = "<div class='chat_message' id='$line_num'>$options You tell <span class='chat_user'><a href='javascript:void(0)' onclick='document.getElementById(\"chat_text\").value = \"/tell ".$receiver['3']." \"; document.getElementById(\"chat_text\").focus(); return false;'>".$receiver['3']."</a></span>: <span class='private'>".str_replace("\n", "", $line)."</span></div>";
			
				// If the chat sender is not the session user, it contains /tell at the beginning and they are not the target
				} else if($receiver['0'] != $user && $receiver['2'] == "/tell" && $receiver['3'] != $user) {
				
					// Hide any private message that is not meant for the user.  If an admin is logged in, show all private messages
					if($admin == 1) {
						$replace = array("/tell ".$receiver['3']);
						$replacement = array("");
						$line = str_replace($replace, $replacement, $line);
				
						$text[] = "<div class='chat_message' id='$line_num'>$options <span class='chat_user'><a href='javascript:void(0)' onclick='document.getElementById(\"chat_text\").value = \"/tell ".$receiver['0']." \"; document.getElementById(\"chat_text\").focus(); return false;'>".$receiver['0']."</a></span> tells <span class='chat_user'><a href='javascript:void(0)' onclick='document.getElementById(\"chat_text\").value = \"/tell ".$receiver['3']." \"; document.getElementById(\"chat_text\").focus(); return false;'>".$receiver['3']."</a></span>: <span class='private'>".str_replace("\n", "", $line)."</span></div>";
					} else
						$text[] = "";
				
				// If the chat sender is not the session user, it contains /tell at the beginning and they are the target
				} else if($receiver['0'] != $user && $receiver['2'] == "/tell" && $receiver['3'] == $user) {
	
					// Remove /tell user
					$replace = array("/tell ".$receiver['3']);
					$replacement = array("");
					$line = str_replace($replace, $replacement, $line);
				
					// Create the private message to the user
					$text[] = "<div class='chat_message' id='$line_num'>$options <span class='chat_user'><a href='javascript:void(0)' onclick='document.getElementById(\"chat_text\").value = \"/tell ".$receiver['0']." \"; document.getElementById(\"chat_text\").focus(); return false;'>".$receiver['0']."</a></span> tells you: <span class='private'>".str_replace("\n", "", $line)."</span></div>";
					
				// If someone is trying to make an announcement.
				} else if($receiver['2'] == "/announce") {
			
					// Remove /announce
					$replace = array("/announce ");
					$replacement = array("");
					$line = str_replace($replace, $replacement, $line);
			
					$text[] = "<div class='chat_message' id='$line_num'>$options <span class='system_user'>".$receiver['0']."</span>: ".str_replace("\n", "", $line)."</span></div>";

				} else {
				
					// If the sender is the user, no need to allow to click their own name
					if($receiver['0'] == $user)
						$text[] = "<div class='chat_message' id='$line_num'>$options <span class='chat_user'>".$receiver['0']."</span>: ".str_replace("\n", "", $line)."</div>";
					else
						$text[] = "<div class='chat_message' id='$line_num'>$options <span class='chat_user'><a href='javascript:void(0)' onclick='document.getElementById(\"chat_text\").value = \"/tell ".$receiver['0']." \"; document.getElementById(\"chat_text\").focus(); return false;'>".$receiver['0']."</a></span>: ".str_replace("\n", "", $line)."</div>";
		
				}
			
			}

		}

                if(isset($text))
    		        $log['text'] = $text;

	}

}

	echo json_encode($log);	
	   
?>