<?php
if($_SERVER['REQUEST_METHOD'] === "POST") {

	if(!ctype_digit($_POST['post_limit']) || !ctype_digit($_POST['ban_time']))
		$error = "Post limit and Ban length must be numerical.";

	if(empty($_POST['db_name']) || empty($_POST['db_server']) || empty($_POST['db_user']) || empty($_POST['db_pass']) || empty($_POST['post_limit']) || empty($_POST['ban_time']))
		$error = "Please fill in all fields.";

	if(empty($error)) {
	
		if(!@mysqli_connect($_POST['db_server'], $_POST['db_user'], $_POST['db_pass'], $_POST['db_name']))
			$error = "Database Connection Failed!<br />".mysqli_connect_error();
			
		if(empty($error)) {
		
			$connection = mysqli_connect($_POST['db_server'], $_POST['db_user'], $_POST['db_pass'], $_POST['db_name']);
			
			$sql = mysqli_query($connection, "CREATE TABLE `chat_users` (
							 `user` varchar(20) NOT NULL,
							 `pass` varchar(128) NOT NULL,
							 `admin` enum('0','1') NOT NULL
							 )");
							 
			if(mysqli_error($connection))
				$error = "Database Table Creation Failed!<br />".mysqli_error($connection);

			if(empty($error)) {
			
				require("../config.php");
			
				$filter = (isset($_POST['filter']) ? 1 : 0);
				$filter_all = (isset($_POST['filter_all']) ? 1 : 0);
				$post_limit = htmlentities(round($_POST['post_limit']));
				$ban_time = htmlentities(round($_POST['ban_time']));
				
				$fopen1 = fopen("../connect.php", 'w') or die("Unable to write the connect.php file.  Please check file permissions.");
				
				$fopen2 = fopen("../config.php", 'w') or die("Unable to write the config.php file.  Please check file permissions.");
			
				fwrite($fopen1, '<?php
$connection = mysqli_connect("'.$_POST['db_server'].'", "'.$_POST['db_user'].'", "'.$_POST['db_pass'].'", "'.$_POST['db_name'].'") or die(mysqli_connect_error())
?>');
				
				fwrite($fopen2, '<?php

define("CURRENT_VERSION", "'.CURRENT_VERSION.'");

// Display message when there is a newer version of the script available? 1 = yes
$display_v = "1";

// Do you want to filter chat? yes = 1
$filter = "'.$filter.'";

// Do you want the filter to not apply to only whole words. yes = 1
// If you filtered rain, and this is not set to 1, rain would be filtered, but a word like rainbow would be left alone.
// If it was set to 1, rain would be filtered, and the rain in rainbow would be filtered
$filter_all = "'.$filter_all.'";

// How many posts do you want to limit the user to send within a 3 second period?
// To clarify, once a message is posted, the count is increased by 1.
// If another message is sent within a 3 second period, it increases again until your set limit, then the user is banned.
$post_limit = "'.$post_limit.'";

// How long would you like a chat ban to last?  In minutes.
$ban_time = "'.$ban_time.'";

?>');
				
				header("Location: install2.php");
				die;
			
			}
		
		}
	
	}

}
?>
<!DOCTYPE html>
<html>

<head>

	<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />

	<title>MDCode | Chat Installation</title>
	
	<link href="../css/bootstrap.css" rel="stylesheet" type="text/css" />
	<link href="../css/chat.css" rel="stylesheet" type="text/css" />

</head>

<body>

<h1 style="text-align: center; color: blue;">MDCode | Chat Installation</h1>
	
<div class="container">

	<div class="row">

		<div class="span8 well" style="text-align: center; margin-left: 150px;">
		
			<h3>Database Settings</h3>
                        <div class="alert alert-warning"><b>ATTENTION</b>: The version of this script requires one SQL user with CREATE, SELECT, INSERT, and UPDATE permissions.  We will be updating to automatically create SQL users in a future update.</div>
			
			<?php
			if(isset($error)) {
			
				echo "<div class='alert alert-error'><b>ERROR</b>: $error</div>";
				
			}
			?>

			<form method="post">

				<input type="text" class="span3" name="db_name" placeholder="MySQL Database Name" value="<?php echo (isset($_POST['db_name']) ? htmlentities($_POST['db_name']) : ''); ?>">
				<input type="text" class="span3" name="db_server" placeholder="MySQL Database Server" value="<?php echo (isset($_POST['db_server']) ? htmlentities($_POST['db_server']) : ''); ?>">
				<input type="text" class="span3" name="db_user" placeholder="MySQL Database User" value="<?php echo (isset($_POST['db_user']) ? htmlentities($_POST['db_user']) : ''); ?>">
				<input type="password" class="span3" name="db_pass" placeholder="MySQL Database Password" value="<?php echo (isset($_POST['db_pass']) ? htmlentities($_POST['db_pass']) : ''); ?>">
				
				<h3>Chat Configurations</h3>
				
				<label class="checkbox">
					<?php
					if(isset($_POST['filter']) && $_POST['filter'] == "Yes")
						echo '<input type="checkbox" name="filter" value="Yes" checked>';
					else if($_SERVER['REQUEST_METHOD'] === "POST" && !isset($_POST['filter']))
						echo '<input type="checkbox" name="filter" value="Yes">';
					else {
					?>
					
					<input type="checkbox" name="filter" value="Yes" checked>
					
					<?php } ?>
				
					Filter Chat <a id="filter" class="btn btn-mini btn-inverse">?</a>
				</label>
				
				
				<label class="checkbox">
					<?php
					if(isset($_POST['filter_all']) && $_POST['filter_all'] == "Yes")
						echo '<input type="checkbox" name="filter_all" value="Yes" checked>';
					else if($_SERVER['REQUEST_METHOD'] === "POST" && !isset($_POST['filter_all']))
						echo '<input type="checkbox" name="filter_all" value="Yes">';
					else {
					?>
					
					<input type="checkbox" name="filter_all" value="Yes">
					
					<?php } ?>
				
					Filter All Matches <a id="filter_all" class="btn btn-mini btn-inverse">?</a>
				</label>
				
				<div class="option">
					Post limit before ban: <input type="text" class="span5" name="post_limit" value="<?php echo ( (isset($_POST['post_limit']) && ctype_digit($_POST['post_limit']) ) ? htmlentities($_POST['post_limit']) : 10 ); ?>"> <a id="post_limit" class="btn btn-mini btn-inverse" style="margin-bottom: 10px;">?</a>
				</div>
				
				<div class="option">				
					Ban length: <input type="text" class="span5" name="ban_time" value="<?php echo ( (isset($_POST['ban_time']) && ctype_digit($_POST['ban_time']) ) ? htmlentities($_POST['ban_time']) : 10 ); ?>" style="margin-left: 62px;"> <a id="ban_length" class="btn btn-mini btn-inverse" style="margin-bottom: 10px;">?</a>		
				</div>

				<button type="submit" class="btn btn-inverse">Check Settings</button>
				
			</form>
		
		</div>

	</div>

</div>

<script src="https://ajax.googleapis.com/ajax/libs/jquery/1.7.1/jquery.min.js"></script>
<script type="text/javascript" src="../js/tooltip.js"></script>
<script type="text/javascript" src="../js/popover.js"></script>

<script>
$('#filter').popover({ title : 'Filter Chat', content: 'Censor all inappropriate whole-words.  Customizable list can be found in functions.php under function filter()', placement : 'right', trigger : 'hover' });
$('#filter_all').popover({ title : 'Filter All', content: 'If yes, chat will no longer only censor whole-words such as "rain".  Non-whole words like "rainbow" will censor "rain".', placement : 'right', trigger: 'hover' });
$('#post_limit').popover({ title : 'Post limit', content: 'The amount of posts (within a 3 second interval each) before a user is banned.', placement : 'right', trigger: 'hover' });
$('#ban_length').popover({ title : 'Ban Length', content: 'How long do you want a ban to last? (In minutes)', placement : 'right', trigger: 'hover' });
</script>

</body>
</html>