function Chat () {
  this.init = chatInit;
  this.update = updateChat;
  this.send = sendChat;
  this.getState = getStateOfChat;
}

function chatInit(){
  getUser();
  getStateOfChat();
}

$.ajaxSetup({
  cache: false // For IE
});

// Function to scroll the chat
function Scroll_Chat() {
  $("#chat_container").css('overflow', 'hidden');  // Fix for some android versions
  $("#chat_container").scrollTop($("#chat_container")[0].scrollHeight);
  $("#chat_container").css('overflow', 'auto');
}

// Function to display content if the user session has expired
function SessionExpired() {
  $("#chat_container").empty();
  $("#chat_container").append($("<div class='inner_center'>Your session has expired.<br /><br /> <a href='chat.php' class='btn btn-primary'>Relaunch</a></div>"));
}

// Function to display content if the user tried to spam
function SpamAttempt() {
  $("#chat_container").append($("<div class='chat_message'><span class='system_user'>System</span>: Please do not spam.</div>"));
  Scroll_Chat();
}

// Function to display content if a user is not an admin
function NoAdmin() {
  $("#chat_container").append($("<div class='chat_message'><span class='system_user'>System</span>: Permission Denied.  Admin permission needed.</div>"));
  Scroll_Chat();
}

// Function to display content if a user is kicked
function userKicked() {
  $("#chat_container").empty();
  $("#chat_container").append($("<div class='inner_center'>You have been kicked from chat.<br /><br /> <a href='chat.php' class='btn btn-primary'>Relaunch</a></div>"));
}

// Function to display content if a user is banned
function userBanned(banned) {

  if(banned <= 0) {
    $("#chat_container").empty();
    $("#chat_container").append($("<div class='inner_center'>Your ban has expired.<br />  You may now chat again.<br /><br /><a href='chat.php' class='btn btn-primary'>Relaunch</a></div>"));
  } else {
    $("#chat_container").empty();
    $("#chat_container").append($("<div class='inner_center'>You have been banned from chat.<br /> You can chat again in " +banned+ " minute(s).</div>"));
    setTimeout('getUser()', 60000);
  }

}

function getUser(){

  $.ajax({
    type: "POST",
    url: "chat/process.php",
    data: {  
      'function': 'getUser'
    },
    dataType: "json",

    success: function(data){
    
      if(data.hasOwnProperty('error')) {
      
        if(data.error == "Expired") {
          expired = 1;
          SessionExpired();
          return false;
        }
      
      } else {
        expired = 0;

        var array = data;
        var info = array.toString().split(',');

        chatUser = info[0];
        adminStatus = info[1];
        kicked = info[2];
        banned = info[3];
        
        setTimeout(function() {

          // If they are kicked
          if(kicked == 1){
            userKicked();
            return false;

          // If they are banned
          } else if(banned != "no"){

              userBanned(banned);
              return false;

          } else {

            // Run this function every 30 seconds
            setTimeout('getUser()', 30000);

          }
          
         }, 500);
      
      }

    }

  });

}

function kickUser(user){

  // If they are not an admin
  if(adminStatus != 1){
    NoAdmin();
    return false;

  // If they are kicked
  } else if(kicked == 1){
    userKicked();
    return false;

  // If they are banned
  } else if(banned != "no"){
    userBanned(banned);
    return false;
  }
	
  $.ajax({

    type: "GET",
    url: "admin/do.php",
    data: {
      'function' : 'kick',
      'user' : user
    },
    dataType: "json",
    cache: false,
    success: function(data) {

      // If an error was found
      if(data.hasOwnProperty('error')){
        
        // If they are not an admin
        if(data.error == "Denied") {
          NoAdmin();
          return false;

        // If the user tries to ban themself
        } else if(data.error == "Invalid User") {
          $("#chat_container").append($("<div class='chat_message'><span class='system_user'>System</span>: The requested user does not exist.</div>"));
          Scroll_Chat();

        // If the user tries to ban themself
        } else if(data.error == "Self Kick") {
          $("#chat_container").append($("<div class='chat_message'><span class='system_user'>System</span>: You can not kick yourself.</div>"));
          Scroll_Chat();

        // If the user has already been kicked
        } else if(data.error == "Repeat") {
          $("#chat_container").append($("<div class='chat_message'><span class='system_user'>System</span>: The requested user has already been kicked.</div>"));
          Scroll_Chat();
        }

      // If there was no error
      } else {
        $("#chat_container").append($("<div class='chat_message'><span class='system_user'>System</span>: " +data+ "</div>"));
        Scroll_Chat();
      }

    }

  });

}

function banUser(user){

  // If they are not an admin
  if(adminStatus != 1){
    NoAdmin();
    return false;

  // If they are kicked
  } else if(kicked == 1){
    userKicked();
    return false;

  // If they are banned
  } else if(banned != "no"){
    userBanned(banned);
    return false;
  }

  $.ajax({

    type: "GET",
    url: "admin/do.php",
    data: {
      'function' : 'ban',
      'user' : user
    },
    dataType: "json",
    cache: false,
    success: function(data) {

      // If an error was found
      if(data.hasOwnProperty('error')){

        // If they are not an admin
        if(data.error == "Denied") {
          NoAdmin();
          return false;

        // If the requested user does not exist
        } else if(data.error == "Invalid User") {
          $("#chat_container").append($("<div class='chat_message'><span class='system_user'>System</span>: The requested user does not exist.</div>"));
          Scroll_Chat();

        // If the user tries to ban themself
        } else if(data.error == "Self Ban") {
          $("#chat_container").append($("<div class='chat_message'><span class='system_user'>System</span>: You can not ban yourself.</div>"));
          Scroll_Chat();

        // If the user has already been banned
        } else if(data.error == "Repeat") {
          $("#chat_container").append($("<div class='chat_message'><span class='system_user'>System</span>: The requested user has already been banned.</div>"));
          Scroll_Chat();
        }

      // If there was no error
      } else {
        $("#chat_container").append($("<div class='chat_message'><span class='system_user'>System</span>: " +data+ "</div>"));
        Scroll_Chat();
      }

    }

  });

}

function deleteMessage(id) {

  // If they are not an admin
  if(adminStatus != 1){
    NoAdmin();
    return false;

  // If they are kicked
  } else if(kicked == 1){
    userKicked();
    return false;

  // If they are banned
  } else if(banned != "no"){
    userBanned(banned);
    return false;
  }

  $.ajax({

    type: "GET",
    url: "admin/do.php",
    data: {
      'function' : 'delete',
      'id' : id
    },
    dataType: "json",
    cache: false,
    success: function(data) {

      // If an error was found
      if(data.hasOwnProperty('error')){

        // If they are not an admin
        if(data.error == "Denied") {
          NoAdmin();
          return false;

        // If the requested message does not exist
        } else if(data.error == "Invalid ID") {
          $("#chat_container").append($("<div class='chat_message'><span class='system_user'>System</span>: The requested message does not exist.</div>"));
          Scroll_Chat();
        }

      // If there was no error
      } else {
        // Empty the message and display deleted
        $("#"+id+"").empty().append("<span class='system_user'>System</span>: Message deleted.");
      }

    }

  });

}

function getStateOfChat(){

  // Make sure the required vars are set before loading chat
  if(typeof expired !== "undefined" && typeof chatUser !== "undefined" && typeof adminStatus !== "undefined" && typeof kicked !== "undefined" && kicked != 1 && typeof banned !== "undefined" && banned == "no") {
  
    if(expired == 1) {
      return false;
    }

    $.ajax({
      type: "POST",
      url: "chat/process.php",
      data: {  
        'function': 'getState'
      },
      dataType: "json",

      success: function(data){
        state = data.state-100; // This number represents how many messages you want shown when the page is first loaded

        updateChat();

      }

    });

  // If the vars are not set, we need to check again
  } else {

    // Run this function again in one second
    setTimeout('getStateOfChat()', 1000)

  }

}
		 
function updateChat(){

  // If they are kicked
  if(kicked == 1){
    userKicked();
    return false;

  // If they are banned
  } else if(banned != "no"){
    userBanned(banned);
    return false;
  }

  $.ajax({

    type: "GET",
    url: "chat/update.php",
    data: {
      'state': state,
      'user' : chatUser,
      'admin' : adminStatus,
      'kicked' : kicked,
      'banned' : banned
    },
    dataType: "json",
    cache: false,
    success: function(data) {

      if($("#loading").css('display') == 'inline')
        $("#loading").css('display', 'none');

      // If there are new messages
      if (data.text != null) {
        for (var i = 0; i < data.text.length; i++) {  
          $('#chat_container').append($(""+ data.text[i] +""));
        }

        Scroll_Chat();

      }

      instanse = false;
      state = data.state;
      setTimeout('updateChat()', 1000);

    }

  });

}

function sendChat(message) {

  // If their session expired, or are kicked or banned
  if(expired == 1 || kicked == 1 || banned != "no") {
    return false;
  }
  
  // Split the messages into an array separated by spaces
  var split = message.split(" ");
  
  // If the start of the message is /ban, a second paramater is set, and not a third, ban the user and return false
  if(adminStatus == 1 && split[0] == "/ban" && split[1] && !split[2]) {
    banUser(""+split[1]+"");
    return false;

  // If the start of the message is /kick, a second paramater is set, and not a third, ban the user return false
  } else if(adminStatus == 1 && split[0] == "/kick" && split[1] && !split[2]) {
    kickUser(""+split[1]+"");
    return false
  }

  if(split[0] == "/tell" && split[1] && !split[2]) {
    $("#chat_container").append("<div class='chat_message'><span class='system_user'>System</span>: Your private message can not be left blank.</div>");
    Scroll_Chat();
    return false;
  } else if(split[0] == "/tell" && split[1] && split[2] && $.trim(split[2]) == "") {
    $("#chat_container").append("<div class='chat_message'><span class='system_user'>System</span>: Your private message can not be left blank.</div>");
    Scroll_Chat();
    return false;
  }

  // You can set new commands here, (separate by comma).  Be sure to update both var commands and var execute to make sure they run.
  var commands = ["/help"];

  if(adminStatus == 1) {
    var execute = ['Chat Commands:<br />/help - Displays all commands.<br />/announce message - Create an announcement.<br />/ban user - Bans a user from chat.<br />/kick user - Kicks a user out of chat.<br />/tell user message - Send a private message to a specified user.'];
  } else {
    var execute = ['Chat Commands:<br />/help - Displays all commands.<br />/tell user message - Send a private message to a specified user.'];
  }

  // If a command was found
  if($.inArray(message, commands) >= 0) {

    // Get the matching position of commands to execute, execute, and scroll the chat
    var position = jQuery.inArray(message, commands);
    $('#chat_container').append($("<div class='chat_message'><span class='system_user'>System</span>: "+ execute[position] +"</div>"));
    Scroll_Chat();

  } else {

    $.ajax({
      type: "POST",
      url: "chat/process.php",
      data: {  
        'function': 'send',
        'message': message
      },
      dataType: "json",
      success: function(data){

        // If an error was found
        if(data.hasOwnProperty('error')){

          // If they are kicked
          if(data.error == "Kicked") {
            kicked = 1;
            userKicked();
            return false;
          }

          // If they are banned
          if(data.error == "Banned") {

            userBanned(data.time_left);
            getUser();
            return false;

          }
					
          // If the user tried to private message themself
          if(data.error == "Self Tell") {

            $("#chat_container").append($("<div class='chat_message'><span class='system_user'>System</span>: You can not send a private message to yourself.</div>"));
            Scroll_Chat();

          }

          // If the user tried to execute an admin command
          if(data.error == "Denied") {

            NoAdmin();
            return false;

          }

        }

      }

    });

  }

}